/*Music for Computer
  - a chuck file - download IDE http://audicle.cs.princeton.edu/mini/
  or chuck : http://chuck.cs.princeton.edu/release/
 ...........the code will run till you stop it*/

Impulse im1 => Gain g1 => HPF hp1 => dac.left;
Impulse im2 => Gain g2 => HPF hp2 => dac.right;
0.1 => g1.gain;
0.1 => g2.gain;
25 => hp1.freq => hp2.freq;

class MusicForComputer
{
    int s;int s1; int s0; int s2;float sf;
    int sb; int sb1; int sb0; int sb2;float sbf;
    int sc;int sc1; int sc0; int sc2;float scf;
    int sd;int sd1; int sd0; int sd2;float sdf;
    int sx; int sx1; int sx0; int sx2;float sxf;
    int sbx; int sbx1; int sbx0; int sbx2;float sbxf;
    int scx; int scx1; int scx0; int scx2;float scxf;
    int sdx; int sdx1; int sdx0; int sdx2;float sdxf;
    0 => float i =>  float ix => float ib => float ibx => float ic =>  float icx => float id => float idx;
    0.1 => float r1 => float r; 0 => float t; 
    0.1 => float rb1 => float rb; 0 => float tb;
    0.1 => float rc1 => float rc; 0 => float tc;
    0.1 => float rd1 => float rd; 0 => float td;
    0.001 => float rx1 => float rx; 0 => float tx; float yx;
    0.001 => float rbx1 => float rbx; 0 => float tbx; float ybx;
    0.001 => float rcx1 => float rcx; 0 => float tcx; float ycx;
    0.001 => float rdx1 => float rdx; 0 => float tdx; float ydx;
    
    0.5 => float fac; 1 => float offsety;
    1 => int imove => int imovex => int imoveb => int imovebx => int imoved => int imovedx => int imovec => int imovecx;
    
    0 => float x1 => float x2 => float x3 => float x4;
    1002077 => float tonenmb; 
    51 => int iteration => int iterationx => int iterationb => int iterationbx => int iterationc => int iterationcx => int iterationd => int iterationdx; 
    8 => float scale; 16 => float scalex;
    0 => float r0 => float rx0 => float rb0 => float rbx0 => float rc0 => float rcx0 => float rd0 => float rdx0;
    0.3 => float ampa => float ampa1 => float ampb => float ampb1 => float ampc => float ampc1 => float ampd => float ampd1;
    0 => float ampa0 => float ampb0 => float ampc0 => float ampd0;0 =>  float ampa2 => float ampb2 =>  float ampc2 => float ampd2;
    7 => int ampmod; 31 => float ampmod1; 11 => float ampadd; 43 => float ampdiv;
    
    41 => float inpol;
    0 => int check; float r2;float rb2; float rc2; float rd2;
    
    fun float f(int prime, int sseed, int sseedb, int sseedc, int sseedd)
    {
        prime => float primef => tonenmb;
        Math.ceil(tonenmb/(500/ scale)) => float offset;

        (prime+ 1) / 2 => int modmove;
        sseed => s => sx;
        sseedb => sb => sbx;
        sseedc => sc => scx;
        sseedd => sd => sdx;

        while ( true)
        {
            
            if (i == 0){
                sx + 2 => iteration;
                ampa1 => ampa0;
                ampa => ampa1;
                s*s % prime => s0;//S7
                s0*s % prime => s1;
                64*s1 % prime => s1;
                112*s0 % prime => s0;
                (7 - 56*s) % prime => s2;
                (s0 + s2 - s1) % prime => s0;
                s0*s0 % prime => s0;
                (s0*s % prime + prime) % prime  => s => sf;
                r1 => r0;
                sf % tonenmb => sf;
                (sf+offset)/(scale*(tonenmb+offset)) => r1;
                
                if (imovex == 0){
                     s => sx;
                     <<< "change s to sx">>>;
                }
                (imovex + 1) % modmove => imovex;
                if(imovex % ampmod == 0)
                {
                    ((s % ampmod1) + ampadd)/ ampdiv => ampb;
                }
            }
            if (ix == 0){
                s  + 2 => iterationx;
               
                sx*sx % prime => sx0; //S5
                16*sx0 % prime => sx0;
                (sx0 - 20*sx + 5) % prime => sx0;
                sx0*sx0 % prime => sx0;
                (sx*sx0 % prime + prime) % prime => sx => sxf;
                rx1 => rx0;
                sxf % tonenmb => sxf;
                (sxf+offset)/(scalex*(tonenmb+offset)) => rx1;
                
                if (imove == 0){
                     sx => s;
                     <<< "change sx to s">>>;
                }
                (imove + 1) % modmove => imove;
            }
            
            if (ib == 0){
                sbx + 2 => iterationb;
                ampb1 => ampb0;
                ampb => ampb1;
                sb*sb % prime => sb0;
                sb0*sb % prime => sb1;
                64*sb1 % prime => sb1;
                112*sb0 % prime => sb0;
                (7 - 56*sb) % prime => sb2;
                (sb0 + sb2 - sb1) % prime => sb0;
                sb0*sb0 % prime => sb0;
                (sb0*s % prime + prime) % prime  => sb => sbf;
                rb1 => rb0;
                sbf % tonenmb => sbf;
                (sbf+offset)/(scale*(tonenmb+offset)) => rb1;
                
                if (imovebx == 0){
                     sb => sbx;
                     <<< "change sb to sbx">>>;
                }
                (imovebx + 1) % modmove => imovebx;
                if(imovebx % ampmod == 0)
                {
                    ((sb % ampmod1) + ampadd)/ ampdiv => ampc;
                }
            }
            if (ibx == 0){
                sb + 2 => iterationbx;
                
                sbx*sbx % prime => sbx0;
                16*sbx0 % prime => sbx0;
                (sbx0 - 20*sbx + 5) % prime => sbx0;
                sbx0*sbx0 % prime => sbx0;
                (sbx*sbx0 % prime + prime) % prime => sbx => sbxf;
                rbx1 => rbx0;
                sbxf % tonenmb => sbxf;
                (sbxf+offset)/(scalex*(tonenmb+offset)) => rbx1;

                if (imoveb == 0){
                     sbx => sb;
                     <<< "change sbx to sb">>>;
                }
                (imoveb + 1) % modmove => imoveb;
            }
            if (ic == 0){
                scx + 2 => iterationc;
                ampc1 => ampc0;
                ampc => ampc1;
                sc*sc % prime => sc0;//S7
                sc0*sc % prime => sc1;
                64*sc1 % prime => sc1;
                112*sc0 % prime => sc0;
                (7 - 56*sc) % prime => sc2;
                (sc0 + sc2 - sc1) % prime => sc0;
                sc0*sc0 % prime => sc0;
                (sc0*sc % prime + prime) % prime  => sc => scf;
                rc1 => rc0;
                scf % tonenmb => scf;
                (scf+offset)/(scale*(tonenmb+offset)) => rc1;
                
                if (imovecx == 0){
                     sc => scx;
                     <<< "change sc to scx">>>;
                }
                (imovecx + 1) % modmove => imovecx;
                if(imovecx % ampmod == 0)
                {
                    ((sc % ampmod1) + ampadd)/ ampdiv => ampd;
                }
            }
            if (icx == 0){
                sc  + 2 => iterationcx;
               
                scx*scx % prime => scx0; //S5
                16*scx0 % prime => scx0;
                (scx0 - 20*scx + 5) % prime => scx0;
                scx0*scx0 % prime => scx0;
                (scx*scx0 % prime + prime) % prime => scx => scxf;
                rcx1 => rcx0;
                scxf % tonenmb => scxf;
                (scxf+offset)/(scalex*(tonenmb+offset)) => rcx1;
                
                if (imovec == 0){
                     scx => sc;
                     <<< "change scx to sc">>>;
                }
                (imovec + 1) % modmove => imovec;
                
            }
            if (id == 0){
                sdx + 2 => iterationd;
                ampd1 => ampd0;
                ampd => ampd1;
                sd*sd % prime => sd0;//S7
                sd0*sd % prime => sd1;
                64*sd1 % prime => sd1;
                112*sd0 % prime => sd0;
                (7 - 56*sd) % prime => sd2;
                (sd0 + sd2 - sd1) % prime => sd0;
                sd0*sd0 % prime => sd0;
                (sd0*sd % prime + prime) % prime  => sd => sdf;
                rd1 => rd0;
                sdf % tonenmb => sdf;
                (sdf+offset)/(scale*(tonenmb+offset)) => rd1;
                
                if (imovedx == 0){
                     sd => sdx;
                     <<< "change sd to sdx">>>;
                }
                (imovedx + 1) % modmove => imovedx;
                if(imovedx % ampmod == 0)
                {
                    ((sd % ampmod1) + ampadd)/ ampdiv => ampa;
                }
            }
            if (idx == 0){
                sd  + 2 => iterationdx;
               
                sdx*sdx % prime => sdx0; //S5
                16*sdx0 % prime => sdx0;
                (sdx0 - 20*sdx + 5) % prime => sdx0;
                sdx0*sdx0 % prime => sdx0;
                (sdx*sdx0 % prime + prime) % prime => sdx => sdxf;
                rdx1 => rdx0;
                sdxf % tonenmb => sdxf;
                (sdxf+offset)/(scalex*(tonenmb+offset)) => rdx1;
                
                if (imoved == 0){
                     sdx => sd;
                     <<< "change sdx to sd">>>;
                }
                (imoved + 1) % modmove => imoved;
            }
            if(i < inpol)                                   // short linear interpolation
            {
              ((i+1)/ inpol) *(r1 - r0) + r0 => r2;
              ((i+1)/ inpol) *(ampa1 - ampa0) + ampa0 => ampa2;
            }
            if(ib < inpol)
            {
              ((ib+1)/ inpol) *(rb1 - rb0) + rb0 => rb2;
              ((ib+1)/ inpol) *(ampb1 - ampb0) + ampb0 => ampb2;
            }
            if(ic < inpol)
            {
              ((ic+1)/ inpol) *(rc1 - rc0) + rc0 => rc2;
              ((ic+1)/ inpol) *(ampc1 - ampc0) + ampc0 => ampc2;
            }
            if(id < inpol)
            {
              ((id+1)/ inpol) *(rd1 - rd0) + rd0 => rd2;
              (id/ inpol) *(ampd1 - ampd0) + ampd0 => ampd2;
            }
            if(ix < inpol)
            {
              ((ix+1)/ inpol) *(rx1 - rx0) + rx0 => rx;
            }
            if(ibx < inpol)
            {
              ((ibx+1)/ inpol) *(rbx1 - rbx0) + rbx0 => rbx;
            }
            if(icx < inpol)
            {
              ((icx+1)/ inpol) *(rcx1 - rcx0) + rcx0 => rcx;
            }
            if(idx< inpol)
            {
              ((idx+1)/ inpol) *(rdx1 - rdx0) + rdx0 => rdx;
            }
           
            if (rx*tx == 1){
                -1000 => tx;
                1 => yx;
            }else{
                (tx+rx1)/(1-tx*rx1) => tx; 
                offsety + fac * 2*tx/ (1+ tx*tx) => yx;
            }
            if (rbx*tbx == 1){
                -1000 => tbx;
                1 => ybx;
            }else{
                (tbx+rbx1)/(1-tbx*rbx1) => tbx; 
                offsety + fac * 2*tbx/ (1+ tbx*tbx) => ybx;
            }
            if (rcx*tcx == 1){
                -1000 => tcx;
                1 => ycx;
            }else{
                (tcx+rcx1)/(1-tcx*rcx1) => tcx; 
                offsety + fac*2*tcx/ (1+ tcx*tcx) => ycx;
            }
            if (rdx*tdx == 1){
                -1000 => tdx;
                1 => ydx;
            }else{
                (tdx+rdx1)/(1-tdx*rdx1) => tdx; 
                offsety + fac*2*tdx/ (1+ tdx*tdx)=> ydx;
            }
            
            r2 * yx  => r; 
            rb2 * ybx  => rb;
            rc2 * ycx  => rc;
            rd2 * ydx  => rd;
            
            if (r*t == 1){
                -1000 => t;
                0 => x1;
            }else{
                (t+r)/(1-t*r) => t; // calculating new circle parameter t
                2*t/ (1+ t*t) => x1; // output
            }
            if (rb*tb == 1){
                -1000 => tb;
                0 => x2;
            }else{
                (tb+rb)/(1-tb*rb) => tb; // calculating new circle parameter t
                2*tb/ (1+ tb*tb) => x2;
            }
            if (rc*tc == 1){
                -1000 => tc;
                0 => x3;
            }else{
                (tc+rc)/(1-tc*rc) => tc; // calculating new circle parameter t
                2*tc/ (1+ tc*tc) => x3; // output
            }
            if (rd*td == 1){
                -1000 => td;
                0 => x4;
            }else{
                (td+rd)/(1-td*rd) => td; // calculating new circle parameter t
                2*td/ (1+ td*td) => x4;
            }
            
             ampa2*x1 + ampc2*x3 => im1.next;
             ampb2*x2 + ampd2*x4 => im2.next;


            (i+1) % iteration => i;
            (ix+1) % iterationx => ix;   
            (ib+1) % iterationb => ib;
            (ibx+1) % iterationbx => ibx;
            (ic+1) % iterationc => ic;
            (icx+1) % iterationcx => icx; 
            (id +1) % iterationd => id;
            (idx+1) % iterationdx => idx; 

            
            1::samp => now; 
        }
    }
} 

MusicForComputer mfc;

mfc.f(1002077, 543984,758767, 67581, 321459);
 /* function variables (ints): 
 the 4 seeds (last) can be varied to create a different piece,
 the  prime (first) could also be varied to other of similar size, but the seeds will be enough;*/
 

